vexpower = {}
vexpower.combobar = {}
vexpower.combopoints = 0
vexpower.infight = false
vexpower.energytype = "ENERGY"
vexpower.maxwidth = 0
vexpower.maxenergy = 100
vexpower.maxenergy_prev = 100
vexpower.currentenergy = 100
vexpower.currentenergy_prev = 100
vexpower.markers = {nil}
vexpower.maxcps = 5
vexpower.currentcps = 0
vexpower.currentcps_prev = 0
vexpower.show = false
vexpower.stealth = false
vexpower.class = ""

vexpower.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexpower.AceConfig = LibStub("AceConfig-3.0", true);
vexpower.AceConsole= LibStub("AceConsole-3.0", true);
vexpower.LSM = LibStub("LibSharedMedia-3.0", true);
vexpower.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true);

SLASH_vexpower1 = "/vexpower"
function SlashCmdList.vexpower(msg, editbox)
	if 	msg == "options" then InterfaceOptionsFrame_OpenToCategory(vexpower.options.main)
	elseif 	msg == "option" then InterfaceOptionsFrame_OpenToCategory(vexpower.options.main)
	elseif 	msg == "config" then InterfaceOptionsFrame_OpenToCategory(vexpower.options.main)
	elseif 	msg == "configs" then InterfaceOptionsFrame_OpenToCategory(vexpower.options.main)
	elseif 	msg == "defaults" then print("|CFFFF7D0AVex Power|r - defaults loaded") vexpower_loaddefaults(true)
	else print("|CFFFF7D0AVex Power|r - cmd not found")
	end
end

function vexpower_onEvent(self, event, arg1, arg2, ...)
	if		event == "PLAYER_LOGIN" 		then vexpower_initialize(false)
	elseif	event == "PLAYER_ENTER_COMBAT"	then vexpower.infight=true vexpower_showEnergybars()
	elseif	event == "PLAYER_LEAVE_COMBAT"	then vexpower.infight=false vexpower_showEnergybars()
	elseif	event == "UPDATE_STEALTH" 		then vexpower.stealth=IsStealthed() vexpower_showEnergybars()
	elseif	event == "UNIT_DISPLAYPOWER"	then
		vexpower_setEnergyType()
		vexpower_showEnergybars()
		vexpower_changeEnergy(true)
	end
end

function vexpower_setEnergyType()
	vexpower.energytype = select(2, UnitPowerType("player"))
	vexpower_setEnergybarColor()
end

function vexpower_onUpdate()
	if vexpower_parameters["frame"]["show"] then
		if UnitPower("player") ~= vexpower.currentenergy then vexpower_changeEnergy() end
		
		if vexpower.class == "DRUID" or vexpower.class == "ROGUE" then
			if GetComboPoints("player") ~= vexpower.currentcps then vexpower_changeCps() end
		elseif vexpower.class == "PALADIN" then
			if UnitPower("player", 9) ~= vexpower.currentcps then vexpower_changeCps() end
		elseif vexpower.class == "WARLOCK" then
			if UnitPower("player", 7) ~= vexpower.currentcps then vexpower_changeCps() end
		end
	end
end

function vexpower_initialize(refresh)
	if not(refresh) then
		print("|CFFFF7D0AVex Power|r started")
		vexpower_loaddefaults()
		vexpower_energyTextbar = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_energybar = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_energybarDif = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_energytext_left = vexpower_energyTextbar:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		vexpower_energytext_right = vexpower_energyTextbar:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		vexpower_cpsbar_1 = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_cpsbar_2 = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_cpsbar_3 = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_cpsbar_4 = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_cpsbar_5 = CreateFrame("Frame", nil, vexpower_energybarbg)
	end
		
	vexpower_setMaxWidth()
	vexpower_setClass()
	vexpower_setCpsMax()
	vexpower_setCpsCurrent()
	vexpower_setEnergyCurrent()
	vexpower_setEnergyType()
	
	vexpower_setEnergybarBG()
	vexpower_setEnergybar()
	vexpower_setEnergybarDif()
	vexpower_setEnergyTextbar()
	vexpower_setFontStrings()
	vexpower_changeEnergyText()
	
	vexpower_setCpsBars()
	
	vexpower_showEnergybars()
	vexpower_setMarkers()
	vexpower_changeEnergy()
	
	
	if not(refresh) then
		vexpower.options = {}
		vexpower.options.main = vexpower.AceConfigDialog:AddToBlizOptions("Vex Power", "Vex Power")
		vexpower.options.frame = vexpower.AceConfigDialog:AddToBlizOptions("EnergyBar", "EnergyBar", "Vex Power")
		vexpower.options.text = vexpower.AceConfigDialog:AddToBlizOptions("Tag-Text", "Tag-Text", "Vex Power")
		vexpower.options.cps = vexpower.AceConfigDialog:AddToBlizOptions("ComboPoints", "ComboPoints", "Vex Power")
		vexpower.options.markers = vexpower.AceConfigDialog:AddToBlizOptions("Markers", "Markers", "Vex Power")
		vexpower.options.show = vexpower.AceConfigDialog:AddToBlizOptions("Show", "Show", "Vex Power")
		vexpower.AceConfig:RegisterOptionsTable("Vex Power", vexpower.panel_main(), {})
		vexpower.AceConfig:RegisterOptionsTable("EnergyBar", vexpower.panel_energybar(), {})
		vexpower.AceConfig:RegisterOptionsTable("Tag-Text", vexpower.panel_text(), {})
		vexpower.AceConfig:RegisterOptionsTable("ComboPoints", vexpower.panel_cps(), {})
		vexpower.AceConfig:RegisterOptionsTable("Markers", vexpower.panel_markers(), {})
		vexpower.AceConfig:RegisterOptionsTable("Show", vexpower.panel_show(), {})
	end
end

function vexpower_setMarkers()
	--Clear Markers
	for i=1,#vexpower.markers do
		if vexpower.markers[i] ~= nil then
			vexpower.markers[i]:Hide()
		end
		vexpower.markers[i]=nil
	end
	vexpower.markers = {}
	
	--Set new markers
	local markers = vexpower_parameters["frame"]["energy"]["markers"]["points"]
	for key,val in pairs(markers) do
		local xposition = vexpower_getEnergyWidth(val)
		if xposition < vexpower.maxwidth then
			local temp = CreateFrame("Frame", nil, vexpower_energyTextbar)
			temp:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
								edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=vexpower_parameters["frame"]["energy"]["markers"]["border"]["size"]})
			temp:SetBackdropColor(vexpower_parameters["frame"]["energy"]["markers"]["color"]["r"],
												vexpower_parameters["frame"]["energy"]["markers"]["color"]["g"],
												vexpower_parameters["frame"]["energy"]["markers"]["color"]["b"],
												vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"])
			temp:SetBackdropBorderColor(vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"],
												vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"],
												vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"],
												vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"])
			temp:SetWidth(vexpower_parameters["frame"]["energy"]["markers"]["width"])
			temp:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2)-4)
			
			temp:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", xposition, -vexpower_parameters["frame"]["energy"]["border"]["size"]-2)
			temp:Show()
			
			table.insert(vexpower.markers,#vexpower.markers+1, temp)
		end
	end
end

function vexpower_setMaxWidth()
	local newwidth = vexpower_parameters["frame"]["energy"]["size"]["width"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2)
	if vexpower.maxwidth ~= newwidth then
		vexpower.maxwidth = newwidth
		vexpower_setMarkers()
	end
end

function vexpower_setEnergyMax()
	if UnitPowerMax("player") ~= vexpower.maxenergy then
		vexpower.maxenergy_prev = vexpower.maxenergy
		vexpower.maxenergy = UnitPowerMax("player")
		vexpower_setMarkers()
	end
end

function vexpower_setEnergyCurrent()
	local new = UnitPower("player")
	if new ~= vexpower.currentenergy then
		vexpower.currentenergy_prev = vexpower.currentenergy
		vexpower.currentenergy = new
	end
end

function vexpower_getEnergyWidth(energy)
	local width = 0
	if not(string.find(energy, "%%")) then
		width = (energy / vexpower.maxenergy) * vexpower.maxwidth
	else
		local energypercentage = string.gsub(energy, "%%", "")
		energypercentage = energypercentage/100
		width = energypercentage * vexpower.maxwidth
	end
	if width == 0 then width = 1 end
	return width
end

function vexpower_setCpsCurrent()
	local new = 0
	
	if vexpower.class == "DRUID" or vexpower.class == "ROGUE"	then new = GetComboPoints("player")
	elseif vexpower.class == "PALADIN" 							then new = UnitPower("player", 9)
	elseif vexpower.class == "WARLOCK" 							then new = UnitPower("player", 7)
	end
	
	if new ~= vexpower.currentcps then
		vexpower.currentcps_prev = vexpower.currentcps
		vexpower.currentcps = new
	end
end

function vexpower_setClass()
	vexpower.class = select(2, UnitClass("player"))
end

function vexpower_setCpsMax()
	if vexpower.class == "ROGUE"			then vexpower.maxcps = 5
	elseif vexpower.class == "PALADIN"		then vexpower.maxcps = 3
	elseif vexpower.class == "MONK"			then vexpower.maxcps = 3
	elseif vexpower.class == "DRUID"		then vexpower.maxcps = 5
	elseif vexpower.class == "WARLOCK"		then vexpower.maxcps = 3
	elseif vexpower.class == "DEATHKNIGHT"	then vexpower.maxcps = 6
	else										 vexpower.maxcps = 0 end
end

function vexpower_changeCps()
	vexpower_setCpsCurrent()
	if vexpower.currentcps > vexpower.currentcps_prev then
		--CPs built
		if vexpower.currentcps > 0 then
			vexpower_setCpsBarsBGColor1(true)
			if vexpower_cpsbar_1_anigrp:IsPlaying() then vexpower_cpsbar_1_anigrp:Stop() end
			vexpower_cpsbar_1:Show()
		end
		if vexpower.currentcps > 1 then
			vexpower_setCpsBarsBGColor2(true)
			if vexpower_cpsbar_2_anigrp:IsPlaying() then vexpower_cpsbar_2_anigrp:Stop() end
			vexpower_cpsbar_2:Show()
		end
		if vexpower.currentcps > 2 then
			vexpower_setCpsBarsBGColor3(true)
			if vexpower_cpsbar_3_anigrp:IsPlaying() then vexpower_cpsbar_3_anigrp:Stop() end
			vexpower_cpsbar_3:Show()
		end
		if vexpower.currentcps > 3 then
			vexpower_setCpsBarsBGColor4(true)
			if vexpower_cpsbar_4_anigrp:IsPlaying() then vexpower_cpsbar_4_anigrp:Stop() end
			vexpower_cpsbar_4:Show()
		end
		if vexpower.currentcps > 4 then
			vexpower_setCpsBarsBGColor5(true)
			if vexpower_cpsbar_5_anigrp:IsPlaying() then vexpower_cpsbar_5_anigrp:Stop() end
			vexpower_cpsbar_5:Show()
		end
	else
		--CPs used
		if vexpower.currentcps == 4 then			vexpower_setCpsBarsBGColor5(false) vexpower_cpsbar_5_anigrp:Play()
		elseif vexpower.currentcps == 3 then
			if vexpower.currentcps_prev > 4 then 	vexpower_setCpsBarsBGColor5(false) vexpower_cpsbar_5_anigrp:Play() end
													vexpower_setCpsBarsBGColor4(false) vexpower_cpsbar_4_anigrp:Play()
		elseif vexpower.currentcps == 2 then
			if vexpower.currentcps_prev > 4 then 	vexpower_setCpsBarsBGColor5(false) vexpower_cpsbar_5_anigrp:Play() end
			if vexpower.currentcps_prev > 3 then 	vexpower_setCpsBarsBGColor4(false) vexpower_cpsbar_4_anigrp:Play() end
													vexpower_setCpsBarsBGColor3(false) vexpower_cpsbar_3_anigrp:Play()
		elseif vexpower.currentcps == 1 then
			if vexpower.currentcps_prev > 4 then 	vexpower_setCpsBarsBGColor5(false) vexpower_cpsbar_5_anigrp:Play() end
			if vexpower.currentcps_prev > 3 then 	vexpower_setCpsBarsBGColor4(false) vexpower_cpsbar_4_anigrp:Play() end
			if vexpower.currentcps_prev > 2 then	vexpower_setCpsBarsBGColor3(false) vexpower_cpsbar_3_anigrp:Play() end
													vexpower_setCpsBarsBGColor2(false) vexpower_cpsbar_2_anigrp:Play()
		elseif vexpower.currentcps == 0 then
			if vexpower.currentcps_prev > 4 then 	vexpower_setCpsBarsBGColor5(false) vexpower_cpsbar_5_anigrp:Play() end
			if vexpower.currentcps_prev > 3 then 	vexpower_setCpsBarsBGColor4(false) vexpower_cpsbar_4_anigrp:Play() end
			if vexpower.currentcps_prev > 2 then	vexpower_setCpsBarsBGColor3(false) vexpower_cpsbar_3_anigrp:Play() end
			if vexpower.currentcps_prev > 1 then	vexpower_setCpsBarsBGColor2(false) vexpower_cpsbar_2_anigrp:Play() end
													vexpower_setCpsBarsBGColor1(false) vexpower_cpsbar_1_anigrp:Play()
		end
	end
end

function vexpower_changeEnergy(energyTypeChanged)
	if vexpower.show then
		if energyTypeChanged then vexpower_energybar:SetWidth(vexpower.maxwidth)
		else
			if not(vexpower_energybar_anigrp:IsPlaying()) then
				vexpower_setEnergyCurrent()
				vexpower_setEnergyMax()
				vexpower_changeEnergyText()
				
				local barfactor_current = vexpower.currentenergy_prev/vexpower.maxenergy
				local barfactor_new = vexpower.currentenergy/vexpower.maxenergy
				local barfactor = barfactor_new/barfactor_current
				
				local newWidth = vexpower_getEnergyWidth(vexpower.currentenergy)
				if barfactor < 1 then
					local oldWidth = vexpower_getEnergyWidth(vexpower.currentenergy_prev)
					local difWidth = oldWidth - newWidth
					
					vexpower_energybar_ani:SetScale(barfactor, 1)
					if vexpower.class == "WARRIOR" or vexpower.class == "DEATHKNIGHT" then
						vexpower_energybar_anigrp:SetScript("onFinished", function () vexpower_energybar:SetWidth(newWidth) end)
					end
					vexpower_energybar_anigrp:Play()
					
					vexpower_energybarDif:SetWidth(difWidth)
					vexpower_energybarDif:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
								vexpower_parameters["frame"]["energy"]["border"]["size"]+newWidth,
								-vexpower_parameters["frame"]["energy"]["border"]["size"])
					vexpower_energybarDif_anigrp:Play()
					
				else 
					vexpower_energybar:SetWidth(newWidth)
				end
			end
		end
	end
end

function vexpower_changeEnergyText()
	local lefttemplate = vexpower_parameters["frame"]["energy"]["text"]["left"]["text"]
	local righttemplate = vexpower_parameters["frame"]["energy"]["text"]["right"]["text"]
	local percenergy = math.floor((vexpower.currentenergy/vexpower.maxenergy)*100)
	lefttemplate = string.gsub(lefttemplate, "{CurrentEnergy}", vexpower.currentenergy)
	lefttemplate = string.gsub(lefttemplate, "{MaxEnergy}", vexpower.maxenergy)
	lefttemplate = string.gsub(lefttemplate, "{PercEnergy}", ""..percenergy.."%%") -- %-function needs to be escaped with another %

	righttemplate = string.gsub(righttemplate, "{CurrentEnergy}", vexpower.currentenergy)
	righttemplate = string.gsub(righttemplate, "{MaxEnergy}", vexpower.maxenergy)
	righttemplate = string.gsub(righttemplate, "{PercEnergy}", ""..percenergy.."%%") -- %-function needs to be escaped with another %
	
	vexpower_energytext_left:SetText(lefttemplate)
	vexpower_energytext_right:SetText(righttemplate)
end

function vexpower_setCpsBarsBGColor1(standard)
	local number="1"
	if standard then	
		vexpower_cpsbar_1:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["a"])		
	else
		vexpower_cpsbar_1:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["a"])	
	end
end

function vexpower_setCpsBarsBGColor2(standard)
	local number="2"
	if standard then	
		vexpower_cpsbar_2:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["a"])		
	else
		vexpower_cpsbar_2:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["a"])	
	end
end

function vexpower_setCpsBarsBGColor3(standard)
	local number="3"
	if standard then	
		vexpower_cpsbar_3:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["a"])		
	else
		vexpower_cpsbar_3:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["a"])	
	end
end

function vexpower_setCpsBarsBGColor4(standard)
	local number="4"
	if standard then	
		vexpower_cpsbar_4:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["a"])			
	else
		vexpower_cpsbar_4:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["a"])	
	end
end

function vexpower_setCpsBarsBGColor5(standard)
	local number="5"
	if standard then	
		vexpower_cpsbar_5:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"][number]["a"])		
	else
		vexpower_cpsbar_5:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["r"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["g"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["b"],
											vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["a"])	
	end
end

function vexpower_setCpsBars()
	local offset_total = vexpower_parameters["frame"]["combo"]["measure"]["offset"]*2
	local gap_total = (vexpower.maxcps-1)*vexpower_parameters["frame"]["combo"]["measure"]["gap"]
	local width = (vexpower_parameters["frame"]["energy"]["size"]["width"] - gap_total - offset_total)/vexpower.maxcps
	local start = {}
	start[1] = vexpower_parameters["frame"]["combo"]["measure"]["offset"]
	start[2] = start[1]+width+vexpower_parameters["frame"]["combo"]["measure"]["gap"]
	start[3] = start[2]+width+vexpower_parameters["frame"]["combo"]["measure"]["gap"]
	start[4] = start[3]+width+vexpower_parameters["frame"]["combo"]["measure"]["gap"]
	start[5] = start[4]+width+vexpower_parameters["frame"]["combo"]["measure"]["gap"]
	start[6] = start[5]+width+vexpower_parameters["frame"]["combo"]["measure"]["gap"]
	
	local animationduration = 0.3
	
	
	--Setup CP 1
	vexpower_cpsbar_1:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
										edgeSize=vexpower_parameters["frame"]["combo"]["border"]["size"]})
	vexpower_setCpsBarsBGColor1(true)
	vexpower_cpsbar_1:SetBackdropBorderColor(vexpower_parameters["frame"]["combo"]["border"]["color"]["r"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["g"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["b"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["a"])
	vexpower_cpsbar_1:SetHeight(vexpower_parameters["frame"]["combo"]["measure"]["height"])
	if vexpower.currentcps > 0 then vexpower_cpsbar_1:Show()
	else vexpower_cpsbar_1:Hide() end
	
	vexpower_cpsbar_1_anigrp = vexpower_cpsbar_1:CreateAnimationGroup("vexpower_cpsbar_1_anigrp")
	vexpower_cpsbar_1_anigrp:SetLooping("NONE")
	vexpower_cpsbar_1_anigrp:SetScript("OnPlay", function () vexpower_cpsbar_1:Show() end)
	vexpower_cpsbar_1_anigrp:SetScript("OnFinished", function () vexpower_cpsbar_1:Hide() end)
	vexpower_cpsbar_1_ani = vexpower_cpsbar_1_anigrp:CreateAnimation("Alpha")
	vexpower_cpsbar_1_ani:SetDuration(animationduration)
	vexpower_cpsbar_1_ani:SetOrder(1)
	vexpower_cpsbar_1_ani:SetChange(-1)
	
	--Setup CP 2
	vexpower_cpsbar_2:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
										edgeSize=vexpower_parameters["frame"]["combo"]["border"]["size"]})
	vexpower_setCpsBarsBGColor2(true)
	vexpower_cpsbar_2:SetBackdropBorderColor(vexpower_parameters["frame"]["combo"]["border"]["color"]["r"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["g"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["b"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["a"])
	vexpower_cpsbar_2:SetHeight(vexpower_parameters["frame"]["combo"]["measure"]["height"])
	if vexpower.currentcps > 1 then vexpower_cpsbar_2:Show()
	else vexpower_cpsbar_2:Hide() end
	vexpower_cpsbar_2_anigrp = vexpower_cpsbar_2:CreateAnimationGroup("vexpower_cpsbar_2_anigrp")
	vexpower_cpsbar_2_anigrp:SetLooping("NONE")
	vexpower_cpsbar_2_anigrp:SetScript("OnPlay", function () vexpower_cpsbar_2:Show() end)
	vexpower_cpsbar_2_anigrp:SetScript("OnFinished", function () vexpower_cpsbar_2:Hide() end)
	vexpower_cpsbar_2_ani = vexpower_cpsbar_2_anigrp:CreateAnimation("Alpha")
	vexpower_cpsbar_2_ani:SetDuration(animationduration)
	vexpower_cpsbar_2_ani:SetOrder(1)
	vexpower_cpsbar_2_ani:SetChange(-1)
	
	--Setup CP 3
	vexpower_cpsbar_3:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
										edgeSize=vexpower_parameters["frame"]["combo"]["border"]["size"]})
	vexpower_setCpsBarsBGColor3(true)
	vexpower_cpsbar_3:SetBackdropBorderColor(vexpower_parameters["frame"]["combo"]["border"]["color"]["r"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["g"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["b"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["a"])
	vexpower_cpsbar_3:SetHeight(vexpower_parameters["frame"]["combo"]["measure"]["height"])
	if vexpower.currentcps > 2 then vexpower_cpsbar_3:Show()
	else vexpower_cpsbar_3:Hide() end
	vexpower_cpsbar_3_anigrp = vexpower_cpsbar_3:CreateAnimationGroup("vexpower_cpsbar_3_anigrp")
	vexpower_cpsbar_3_anigrp:SetLooping("NONE")
	vexpower_cpsbar_3_anigrp:SetScript("OnPlay", function () vexpower_cpsbar_3:Show() end)
	vexpower_cpsbar_3_anigrp:SetScript("OnFinished", function () vexpower_cpsbar_3:Hide() end)
	vexpower_cpsbar_3_ani = vexpower_cpsbar_3_anigrp:CreateAnimation("Alpha")
	vexpower_cpsbar_3_ani:SetDuration(animationduration)
	vexpower_cpsbar_3_ani:SetOrder(1)
	vexpower_cpsbar_3_ani:SetChange(-1)
	
	--Setup CP 4
	vexpower_cpsbar_4:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
										edgeSize=vexpower_parameters["frame"]["combo"]["border"]["size"]})
	vexpower_setCpsBarsBGColor4(true)
	vexpower_cpsbar_4:SetBackdropBorderColor(vexpower_parameters["frame"]["combo"]["border"]["color"]["r"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["g"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["b"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["a"])
	vexpower_cpsbar_4:SetHeight(vexpower_parameters["frame"]["combo"]["measure"]["height"])
	if vexpower.currentcps > 3 then vexpower_cpsbar_4:Show()
	else vexpower_cpsbar_4:Hide() end
	vexpower_cpsbar_4_anigrp = vexpower_cpsbar_4:CreateAnimationGroup("vexpower_cpsbar_4_anigrp")
	vexpower_cpsbar_4_anigrp:SetLooping("NONE")
	vexpower_cpsbar_4_anigrp:SetScript("OnPlay", function () vexpower_cpsbar_4:Show() end)
	vexpower_cpsbar_4_anigrp:SetScript("OnFinished", function () vexpower_cpsbar_4:Hide() end)
	vexpower_cpsbar_4_ani = vexpower_cpsbar_4_anigrp:CreateAnimation("Alpha")
	vexpower_cpsbar_4_ani:SetDuration(animationduration)
	vexpower_cpsbar_4_ani:SetOrder(1)
	vexpower_cpsbar_4_ani:SetChange(-1)
	
	--Setup CP 5
	vexpower_cpsbar_5:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
										edgeSize=vexpower_parameters["frame"]["combo"]["border"]["size"]})
	vexpower_setCpsBarsBGColor5(true)
	vexpower_cpsbar_5:SetBackdropBorderColor(vexpower_parameters["frame"]["combo"]["border"]["color"]["r"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["g"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["b"],
													vexpower_parameters["frame"]["combo"]["border"]["color"]["a"])
	vexpower_cpsbar_5:SetHeight(vexpower_parameters["frame"]["combo"]["measure"]["height"])
	if vexpower.currentcps > 4 then vexpower_cpsbar_5:Show()
	else vexpower_cpsbar_5:Hide() end
	vexpower_cpsbar_5_anigrp = vexpower_cpsbar_5:CreateAnimationGroup("vexpower_cpsbar_5_anigrp")
	vexpower_cpsbar_5_anigrp:SetLooping("NONE")
	vexpower_cpsbar_5_anigrp:SetScript("OnPlay", function () vexpower_cpsbar_5:Show() end)
	vexpower_cpsbar_5_anigrp:SetScript("OnFinished", function () vexpower_cpsbar_5:Hide() end)
	vexpower_cpsbar_5_ani = vexpower_cpsbar_5_anigrp:CreateAnimation("Alpha")
	vexpower_cpsbar_5_ani:SetDuration(animationduration)
	vexpower_cpsbar_5_ani:SetOrder(1)
	vexpower_cpsbar_5_ani:SetChange(-1)
	
	if vexpower.maxcps>0 then
		vexpower_cpsbar_1:SetWidth(width)
		vexpower_cpsbar_1:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", start[1], vexpower_parameters["frame"]["combo"]["measure"]["y"])
		if vexpower.maxcps>1 then
		vexpower_cpsbar_2:SetWidth(width)
		vexpower_cpsbar_2:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", start[2], vexpower_parameters["frame"]["combo"]["measure"]["y"])
			if vexpower.maxcps>2 then
			vexpower_cpsbar_3:SetWidth(width)
			vexpower_cpsbar_3:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", start[3], vexpower_parameters["frame"]["combo"]["measure"]["y"])
				if vexpower.maxcps>3 then
				vexpower_cpsbar_4:SetWidth(width)
				vexpower_cpsbar_4:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", start[4], vexpower_parameters["frame"]["combo"]["measure"]["y"])
					if vexpower.maxcps>4 then
					vexpower_cpsbar_5:SetWidth(width)
					vexpower_cpsbar_5:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", start[5], vexpower_parameters["frame"]["combo"]["measure"]["y"])
					end
				end
			end
		end
	end
	

end

function vexpower_setEnergybarBG()
	vexpower_energybarbg:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
										edgeSize=vexpower_parameters["frame"]["energy"]["border"]["size"]})
	vexpower_energybarbg:SetBackdropColor(	vexpower_parameters["frame"]["energy"]["bgcolor"]["r"],
											vexpower_parameters["frame"]["energy"]["bgcolor"]["g"],
											vexpower_parameters["frame"]["energy"]["bgcolor"]["b"],
											vexpower_parameters["frame"]["energy"]["bgcolor"]["a"])
	vexpower_energybarbg:SetBackdropBorderColor(	vexpower_parameters["frame"]["energy"]["border"]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["border"]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["border"]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["border"]["color"]["a"])
	vexpower_energybarbg:SetWidth(vexpower_parameters["frame"]["energy"]["size"]["width"])
	vexpower_energybarbg:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"])
	vexpower_energybarbg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", vexpower_parameters["frame"]["energy"]["position"]["x"], vexpower_parameters["frame"]["energy"]["position"]["y"])	
end

function vexpower_setEnergybar()
	vexpower_energybar:SetBackdrop({bgFile=vexpower.LSM:Fetch("background", vexpower_parameters["frame"]["energy"]["bg"]), tile=false,
								edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	vexpower_setEnergybarColor()
	vexpower_energybar:SetBackdropBorderColor(1,1,1,0)
	if vexpower.class == "WARRIOR" or vexpower.class == "DEATHKNIGHT" then vexpower_energybar:SetWidth(0)
	else vexpower_energybar:SetWidth(vexpower.maxwidth) end
	vexpower_energybar:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2))
	vexpower_energybar:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
						vexpower_parameters["frame"]["energy"]["border"]["size"],
						-vexpower_parameters["frame"]["energy"]["border"]["size"])
	vexpower_energybar_anigrp = vexpower_energybar:CreateAnimationGroup("vexpower_energybar_anigrp")
	vexpower_energybar_anigrp:SetLooping("NONE")
	vexpower_energybar_ani = vexpower_energybar_anigrp:CreateAnimation("Scale")
	vexpower_energybar_ani:SetSmoothing("OUT")
	vexpower_energybar_ani:SetDuration(0.2)
	vexpower_energybar_ani:SetOrder(1)
	vexpower_energybar_ani:SetOrigin("TOPLEFT",0,0)
end

function vexpower_setEnergybarColor()
	if vexpower_parameters["frame"]["energy"]["typecolored"] then
		vexpower_energybar:SetBackdropColor(	PowerBarColor[vexpower.energytype].r,
												PowerBarColor[vexpower.energytype].g,
												PowerBarColor[vexpower.energytype].b, 1)
	else
		vexpower_energybar:SetBackdropColor(	vexpower_parameters["frame"]["energy"]["color"]["r"],
												vexpower_parameters["frame"]["energy"]["color"]["g"],
												vexpower_parameters["frame"]["energy"]["color"]["b"],
												vexpower_parameters["frame"]["energy"]["color"]["a"])
	end
end

function vexpower_setEnergyTextbar()
	vexpower_energyTextbar:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	vexpower_energyTextbar:SetBackdropColor(0, 0, 0, 0)
	vexpower_energyTextbar:SetBackdropBorderColor(1,1,1,0)
	vexpower_energyTextbar:SetWidth(vexpower.maxwidth)
	vexpower_energyTextbar:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2))
	vexpower_energyTextbar:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
						vexpower_parameters["frame"]["energy"]["border"]["size"],
						-vexpower_parameters["frame"]["energy"]["border"]["size"])
end

function vexpower_setEnergybarDif()
	vexpower_energybarDif:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})	
	vexpower_energybarDif:SetBackdropColor(	vexpower_parameters["frame"]["energy"]["usedcolor"]["r"],
											vexpower_parameters["frame"]["energy"]["usedcolor"]["g"],
											vexpower_parameters["frame"]["energy"]["usedcolor"]["b"],
											vexpower_parameters["frame"]["energy"]["usedcolor"]["a"])
	vexpower_energybarDif:SetBackdropBorderColor(1,1,1,0)
	vexpower_energybarDif:SetWidth(0)
	vexpower_energybarDif:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2))
	vexpower_energybarDif:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
						vexpower_parameters["frame"]["energy"]["border"]["size"],
						-vexpower_parameters["frame"]["energy"]["border"]["size"])
	vexpower_energybarDif:Hide()
	vexpower_energybarDif_anigrp = vexpower_energybarDif:CreateAnimationGroup("vexpower_energybarDif_anigrp")
	vexpower_energybarDif_anigrp:SetLooping("NONE")
	vexpower_energybarDif_anigrp:SetScript("OnPlay", function () vexpower_energybarDif:Show() end)
	vexpower_energybarDif_anigrp:SetScript("OnFinished", function () vexpower_energybarDif:Hide() end)
	vexpower_energybarDif_ani = vexpower_energybarDif_anigrp:CreateAnimation("Alpha")
	vexpower_energybarDif_ani:SetDuration(0.5)
	vexpower_energybarDif_ani:SetOrder(1)
	vexpower_energybarDif_ani:SetChange(-1)
end

function vexpower_setFontStrings()
	-- FontString 1
	vexpower_energytext_left:SetPoint("TOPLEFT", vexpower_energyTextbar, "TOPLEFT" , vexpower_parameters["frame"]["energy"]["text"]["left"]["x"], vexpower_parameters["frame"]["energy"]["text"]["left"]["y"])
	vexpower_energytext_left:SetTextColor(vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["a"])
	vexpower_energytext_left:SetText("")
	vexpower_energytext_left:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"]["left"]["font"]),
									vexpower_parameters["frame"]["energy"]["text"]["left"]["size"], "OUTLINE")	
	vexpower_energytext_left:SetWidth(vexpower_parameters["frame"]["energy"]["text"]["left"]["width"])	
	vexpower_energytext_left:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"]["left"]["align"])
	
	-- FontString 2
	vexpower_energytext_right:SetPoint("TOPRIGHT", vexpower_energyTextbar, "TOPRIGHT" , vexpower_parameters["frame"]["energy"]["text"]["right"]["x"], vexpower_parameters["frame"]["energy"]["text"]["right"]["y"])
	vexpower_energytext_right:SetTextColor(vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["a"])
	vexpower_energytext_right:SetText("")	
	vexpower_energytext_right:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"]["right"]["font"]),
									vexpower_parameters["frame"]["energy"]["text"]["right"]["size"], "OUTLINE")	
	vexpower_energytext_right:SetWidth(vexpower_parameters["frame"]["energy"]["text"]["right"]["width"])	
	vexpower_energytext_right:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"]["right"]["align"])
	
end

function vexpower_showEnergybars()
	local show = true
	--check for enabled addon
	if vexpower_parameters["frame"]["show"] then
		--check for infight
		if vexpower_parameters["frame"]["infightshow"] and vexpower.infight	then show = true
		elseif not(vexpower_parameters["frame"]["infightshow"])				then show = true
		else show = false end
		
		--check for show not with manapool
		if not(vexpower_parameters["frame"]["energy"]["showwithmana"]) and vexpower.energytype == "MANA" then
			show = false
		end
		
		--check for stealth
		if vexpower_parameters["frame"]["stealthshow"] and vexpower.stealth then
			show = true
		end		
	else show = false end
	

	
	--react to 'show'
	vexpower.show = show
	if show then 	vexpower_energybarbg:Show() 
	else			vexpower_energybarbg:Hide() end
end







