function vexpower.panel_cps()
	return {
		type = "group",
		order= 5,
		args = {
			infopic={name = "", type="description", order=1, image="Interface\\AddOns\\vexpower\\images\\options_cps.tga",
				imageWidth=512, imageHeight=128},
			cp_description = {name = "The 'ComboPoint'-settings also apply to soul-shards and holy power", type="description", order=2},
			frameposition = {name = "ComboPoint Layout", type="header", order=10},
			framey = {
				name = "Y-Distance",
				order=11, type = "range",
				desc = "Sets the distance of the energybar to the combopoints",
				step = 1, min = -400, max = 400,
				set = function(info,val) vexpower_parameters["frame"]["combo"]["measure"]["y"]=val vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["measure"]["y"] end
				},
			frameheight = {
				name = "Height",
				order=12, type = "range",
				desc = "Height of the combopoints",
				step = 1, min = 1, max = 400,
				set = function(info,val) vexpower_parameters["frame"]["combo"]["measure"]["height"]=val vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["measure"]["height"] end
				},
			framebordersize = {
				name = "border size",
				order=15, type = "range",
				desc = "Sets the size of the border",
				step = 1, min = 1, max = 10,
				set = function(info,val) vexpower_parameters["frame"]["combo"]["border"]["size"]=val vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["border"]["size"] end
				},
			framex = {
				name = "X-Distance",
				order=21, type = "range",
				desc = "Sets the distance of the energybar to the combopoints",
				step = 1, min = -400, max = 400,
				set = function(info,val) vexpower_parameters["frame"]["combo"]["measure"]["offset"]=val vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["measure"]["offset"] end
				},
			framegap = {
				name = "Gap",
				order=22, type = "range",
				desc = "Distance between the individual combopoints",
				step = 1, min = 1, max = 400,
				set = function(info,val) vexpower_parameters["frame"]["combo"]["measure"]["gap"]=val vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["measure"]["gap"] end
				},
			framebordercolor = {
				name = "border color",
				order=23, type = "color", hasAlpha=true,
				desc = "Color of border",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["combo"]["border"]["color"]["r"]=r
					vexpower_parameters["frame"]["combo"]["border"]["color"]["g"]=g
					vexpower_parameters["frame"]["combo"]["border"]["color"]["b"]=b
					vexpower_parameters["frame"]["combo"]["border"]["color"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["border"]["color"]["r"],
					vexpower_parameters["frame"]["combo"]["border"]["color"]["g"],
					vexpower_parameters["frame"]["combo"]["border"]["color"]["b"],
					vexpower_parameters["frame"]["combo"]["border"]["color"]["a"] end,
				},
				
			framecolors = {name = "ComboPoint Colors", type="header", order=100},
			framecolors1 = {
				name = "Backgroundcolor of the 1st combopoint (or 1st soulshard/holypower)", width="full",
				order=110, type = "color", hasAlpha=true,
				desc = "Color of the 1st combopoint",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["1"]["r"]=r
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["1"]["g"]=g
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["1"]["b"]=b
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["1"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["bg"]["color"]["1"]["r"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["1"]["g"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["1"]["b"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["1"]["a"] end,
				},
			framecolors2 = {
				name = "Backgroundcolor of the 2nd combopoint (or 2nd soulshard/holypower)", width="full",
				order=120, type = "color", hasAlpha=true,
				desc = "Color of the 2nd combopoint",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["2"]["r"]=r
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["2"]["g"]=g
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["2"]["b"]=b
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["2"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["bg"]["color"]["2"]["r"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["2"]["g"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["2"]["b"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["2"]["a"] end,
				},
			framecolors3 = {
				name = "Backgroundcolor of the 3rd combopoint (or 3rd soulshard/holypower)", width="full",
				order=130, type = "color", hasAlpha=true,
				desc = "Color of the 3rd combopoint",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["3"]["r"]=r
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["3"]["g"]=g
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["3"]["b"]=b
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["3"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["bg"]["color"]["3"]["r"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["3"]["g"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["3"]["b"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["3"]["a"] end,
				},
			framecolors4 = {
				name = "Backgroundcolor of the 4th combopoint", width="full",
				order=140, type = "color", hasAlpha=true,
				desc = "Color of the 4th combopoint",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["4"]["r"]=r
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["4"]["g"]=g
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["4"]["b"]=b
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["4"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["bg"]["color"]["4"]["r"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["4"]["g"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["4"]["b"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["4"]["a"] end,
				},
			framecolors5 = {
				name = "Backgroundcolor of the 5th combopoint", width="full",
				order=150, type = "color", hasAlpha=true,
				desc = "Color of the 5th combopoints",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["5"]["r"]=r
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["5"]["g"]=g
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["5"]["b"]=b
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["5"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["bg"]["color"]["5"]["r"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["5"]["g"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["5"]["b"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["5"]["a"] end,
				},
			framecolorsusedspace = {name = " ", type="description", order=199},
			framecolorsused = {
				name = "Backgroundcolor for a used combopoint that fades out", width="full",
				order=200, type = "color", hasAlpha=true,
				desc = "Color for a used combopoint that fades out",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["r"]=r
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["g"]=g
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["b"]=b
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["r"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["g"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["b"],
					vexpower_parameters["frame"]["combo"]["bg"]["color"]["used"]["a"] end,
				},
			}
		}
end