function vexpower.panel_markers()

	return {
		type = "group",
		order= 5,
		args = {
			infopic={name = "", type="description", order=1, image="Interface\\AddOns\\vexpower\\images\\options_markers.tga",
				imageWidth=512, imageHeight=64},	
			info1={name = "Example-markers in the red circles\n", type="description", order=2,},	
			info2={name = "Markers are marks at specific places on your energybar. They can be placed at absolute positions and at relative positions.", type="description", order=3, fontSize="medium"},	
			info3={name = "Example 1: '50' will be placed on the energybar that represents 50 of your mana/energy/etc", type="description", order=4, fontSize="medium"},	
			info4={name = "Example 2: '50%' will be placed on the energybar that represents 50% of your mana/energy/etc", type="description", order=5, fontSize="medium"},	
			info5={name = "Markers that are placed at the end or outside of the energybar aren't shown", type="description", order=6, fontSize="medium"},	
			info6={name = "Example 3: the marker '140' isn't shown unless the powerbar has at least 141 energy/mana/etc", type="description", order=7, fontSize="medium"},	
			info7={name = "Example 4: the marker '100%' and higher is never shown", type="description", order=8, fontSize="medium"},	
			space1={name= " ", type="description", order=10},
			
			addheader={name="Insert new / delte old 'marker'", type="header", order=50},
			marker_new = {
				name = "Place a new 'marker' at the following location:",
				desc = "Enter a place where to put the new mark",
				order=55, type = "input", multiline = false, width = "double",
				validate = function (info, val)
					if vexpower_panel_markercheck(val) then return true
					else return "ERROR - "..val.." is not a valid position" end
					end,
				set = function(info,val) vexpower_panel_addmarker(val) vexpower_initialize(true) end,
				get = function() return "" end,
				},
			spacenewdelete={name= " ", type="description", order=56},
			marker_delete = {
				name = "Delete an existing marker",
				order=57, type = "select", style = "dropdown",
				desc = "Delete an existing marker",
				values = vexpower_parameters["frame"]["energy"]["markers"]["points"],
				set = function(self,key) vexpower_panel_deletemarker(key) vexpower_initialize(true) end,
				get = function() return "" end,
				},
			
			
			designheader={name="Appearance", type="header", order=100},
			markerswidth = {
				name = "size",
				order=110, type = "range",
				desc = "Sets the width of the marks",
				step = 1, min = 1, max = 10,
				set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["width"]=val vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["energy"]["markers"]["width"] end,
				},
			markersbg = {
				name = "Color of the mark",
				order=115, type = "color", hasAlpha=true,
				desc = "Text color",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["energy"]["markers"]["color"]["r"]=r
					vexpower_parameters["frame"]["energy"]["markers"]["color"]["g"]=g
					vexpower_parameters["frame"]["energy"]["markers"]["color"]["b"]=b
					vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["energy"]["markers"]["color"]["r"],
					vexpower_parameters["frame"]["energy"]["markers"]["color"]["g"],
					vexpower_parameters["frame"]["energy"]["markers"]["color"]["b"],
					vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"] end,
				},
			spacedesign1={name= " ", type="description", order=120},
			markersborderwidth = {
				name = "bordersize",
				order=130, type = "range",
				desc = "Sets the width of the border",
				step = 1, min = 1, max = 10,
				set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["border"]["size"]=val vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["size"] end,
				},
			markersborder = {
				name = "Color of the border",
				order=135, type = "color", hasAlpha=true,
				desc = "Text color",
				set = function(info,r,g,b,a)
					vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"]=r
					vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"]=g
					vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"]=b
					vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"]=a
					vexpower_initialize(true) end,
				get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"],
					vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"],
					vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"],
					vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"] end,
				},
			}
		}
end

function vexpower_panel_addmarker(val)
	if vexpower_panel_markercheck(val) then
		vexpower_parameters["frame"]["energy"]["markers"]["points"][val] = val
	else
		print("|CFFFF7D0AVex Power|r - ERROR --> "..val.." <-- is not a valid 'marker' !")
	end
end

function vexpower_panel_markercheck(val)
	local returnvalue = false
	if string.gsub(val, "^%d+%%?", "") == "" then returnvalue = true end
	if val == "" then returnvalue = false end
	return returnvalue
end

function vexpower_panel_deletemarker(val)
	vexpower_parameters["frame"]["energy"]["markers"]["points"][val]=nil
end